c ************************ MAIN.FOR ************************************
c
c Program SIPT1.FOR -- version 1.0 -- USGS, Hartford, CT -- 08-15-86
c
c Micro-computer implementation of sipt22.fortran (on Denver PRIME).
c Compiled on an IBM PC using the IBM Professional FORTRAN compiler
c (version 1.0).
c Program consists of 9 modules: MAIN.FOR, PART2.FOR, PART3.FOR,
c INITIAL.FOR, S1.FOR, S2.FOR, S3.FOR, S4.FOR and S5.FOR.
c
c This program interprets seismic refraction data for up to 5 spreads,
c each of which with up to 48 geophones and 7 shotpoints, and for 2 to
c 5 layers in the subsurface.
c
c Part 1 computes elevation corrections and plots corrected t-d graph.
c Part 2 computes velocities, makes weath correction, and replots t-d graph.
c Part 3 computes migrated depths and makes smoothed depth interpretation.
c
c **********************************************************************
c
c explicit variable specification
c
	character*2 jchar
	character*32 din,dout,blank
       	character*1 ifprint,jtrl,jprt,jout,idspr,idsp,krs2,krg,ip,it,
     1       ity,idtest,ibl,is,isq,iast,iplus,idash,icoln,idee,iques,
     2       icee,itee,ipee,ibee,ix,il,jvel
      	character*1 begin,br2002
       	character*1 enter2
	character*4 ident,iend
c
c common block assignments
c
	common ibl,iques,ip,it,icoln,iplus,isq,idash,is,iast,idee,il,
     1         ident
	common/ibm1/nl,ln,p,tscale,xscale,xsco2,escale,xlim1,xlim2,
     1              iplot
	common/blk0/lg
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,ity
	common/blk2/xg,erp,slope,idip
	common/blk3/ta,tr,dsg
	common/blk4/vva,vha
	common/blk5/idspr,idsp
	common/ibm3/kl,kr,d
	common/blk6/trp,jjoff
	common/blk7/ja,jb,trs,ers,xsp,esp,ls
	common/blk8/prg,erg,prs2,ers2,zrsp,zrg
	common/ibm4/krg,krs2
	common/blk9/eg,es
	common/blk10/blim,itrace,tansg
	common/blk11/vreg,preg
	common/blk12/vhob,phob
       	common/real1/a,avvdd,big,bl,diff,dmy0,dmy1,dmy2,dmy3,ebar,edat1,
     1    edat2,edg,edsp,eg2,eintg,eref,erg2,erx,es2,gpt,gtc,pg2,prg2,
     2    prp,ps2,pts,pts1,pts2,pts3,sppt,sptc,sum1,sum2,sum3,tcg,
     3    tfudge,tg2,tlim,trg,trg2,trs2,tuh,tvg,tvs,vdd,vv,xbar,xcg,
     4    xdat1,xdat2,xintg,xlast,xref,xs,xshift,xtie,xvg,yg,ysp,zsg,
     5    zsp
       	common/real2/b,denex,dg2,edif,eint,hv,pbar,prsh,pt,rad,rads,ray,
     1    t,tbar,tc,th,ts,v,vocosg,vvcosg,x1,x2,xc,xint,xtru,z,ztan,ztru
       	common/real3/dg,ds,dz,e1,e2,ells,hv2,p1,p2,s1,s2,sgn,tcall,tcor,
     1    tg,tlls,v1,xd,xlls
       	common/char1/blank,din,dout,ibee,icee,idtest,iend,ifprint,ipee,
     1    itee,ix,jout
       	common/char2/begin,br2002
      	common/char3/enter2
       	common/integ1/i,i1,iexit,iopen,iover,irep,ixit,ixtrue,iz,j,j1,
     1    jc,jexit,jn,jopen,jr,k,kn,ktest,l,l1,l2,lr,m,mj,mk,ml,ml1,mm,
     2    nixit,nv
       	common/integ2/icall,iflag,ii,j2,jcall,jj,jjj,jjtie,k1,k11,k2,
     1    k22,kcall,kk,kt1,kt2,lcall,mcall
       	common/integ3/isplt,ixrep,jt,ll,m1,none
c
c arrays
c
	dimension ident(20),ip(103),it(53),
     1   il(5),vreg(5),vhob(5),preg(5),phob(5),zsg(4),
     2   idspr(5),nj(5),nk(5),xshift(5),ja(5),jb(5),bl(5),
     3   vva(5,5),vha(5,5),
     4   tvs(7),avvdd(7),zrsp(7),idsp(7,5),esp(7,5),
     5   xsp(7,5),ysp(7,5),zsp(7,5),tuh(7,5),edsp(7,5),
     6   tfudge(7,5),es(7,5),kl(7,5),kr(7,5),sptc(7,5),sppt(7,5),
     7   ls(7,5),zrg(48,7),
     8   ps2(7,5,2),es2(7,5,2),trs2(7,5,2),
     9   ers(7,5,4),trs(7,5,4),
     1   ers2(7,5,4,2),prs2(7,5,4,2),krs2(7,5,4,2),
     1   tvg(48),xvg(48),dsg(48),prp(48),xs(48),erx(48),
     2   prg2(48,2),erg2(48,2),trg2(48,2),
     3   tcg(48,2),xcg(48,2),xintg(48,2),eintg(48,2),
     4   edg(48,5),eg(48,5),xg(48,5),yg(48,5),
     5   gtc(48,5),gpt(48,5),
     6   pg2(48,5,2),eg2(48,5,2),tg2(48,5,2),
     7   erp(48,5,4),trp(48,5,4),ta(48,7,5),
     8   tr(48,7,5),lg(48,7,5),d(48,7,5),vdd(48,7,5),p(48,7,5),
     9   prg(48,7,5),erg(48,7,5),trg(48,7,5),krg(48,7,5)
c
c ***********  part 1  *******************************************************
c
c data initialization
c
      	mm=5
       	mj=7
       	mk=48
       	ml=5
       	ml1=4
       	iz=0
       	i1=1
       	big=9999999.
      	iend='end'
       	ibl=' '
       	is='s'
       	isq='#'
       	iast='*'
       	iplus='+'
       	idash='-'
       	icoln=':'
       	idee='>'
       	iques='?'
       	icee='c'
       	itee='t'
       	ipee='p'
       	ibee='b'
       	ix='x'
       	il(1)='1'
       	il(2)='2'
       	il(3)='3'
       	il(4)='4'
       	il(5)='5'
       	blank='                                '
       	br2002='n'
       	enter2='n'
 	din=blank
	iopen=0
       	jopen=0
c
c input data file, format type, and output unit specification from terminal
c
1	write(*,10000)
10000	format(/,
     1' Welcome to the PC refraction interpretation program SIPT1.'/
     2' If you have any questions about the use of this program, please'
     3/' refer to the documentation in the USGS Open File Report.'/
     4' Please use lower case for all input from the terminal.  Good luc
     5k!',
     6//,' Enter input file name (or <cr> to exit):',/)
	read (*,10002) din
10002	format(a32)
	if(din.eq.blank) go to 9999
       	if(iopen.eq.0) go to 10003
       	close (10)
10003  	open (10,file=din,status='old',form='formatted')
       	iopen=1
        begin='n'
	ifprint=ibl
c
	write(*,10004)
10004	format(' Enter input format type (c=card, f=free field):',/)
	read (*,10006) ifprint
10006	format(a1)
	if(ifprint.ne.icee) ifprint=itee
c
	write(*,10007)
10007	format(
     1' Enter output unit (p=printer, t=terminal, b=both):',/)
	jprt=ix
	jtrl=ix
	read (*,10006) jout
	if (jout.eq.ipee) jtrl=ibl
	if (jout.eq.itee) jprt=ibl
c
c initialization of arrays, etc.
10008	call initial
c
c read input data file
c title card
	read(10,9) ident
9	format (20a4)
	if (ident(1).eq.iend) go to 1
c problem control card
	if(ifprint.eq.icee) read(10,11) nm,iexit,nl,nv,escale,xscale,
     1   tscale,edat1,xdat1,edat2,xdat2,slope,a,blim,tlim,itrace,
     2   jjoff,idip
11	format (i1,i2,2(1x,i1),1x,3(f4.0,1x),4f7.1,f7.4,f7.1,f7.2,f4.1,
     1	 1x,3i1)
	if(ifprint.eq.itee) read(10,*) nm,iexit,nl,nv,escale,xscale,
     1   tscale,edat1,xdat1,edat2,xdat2,slope,a,blim,tlim,itrace,jjoff,
     2   idip
	ixit=0
	if (iabs(iexit).le.6) ixit=iexit
	if (nl.le.1) nl=2
	if (nm.eq.0) nm=1
	if (blim.eq.0.0) blim=0.5
	if (escale.eq.0.) escale=5.0
	if (xscale.eq.0.) xscale=8.3333333
	if (tscale.eq.0.) tscale=1.0
	if (tlim.eq.0.0) tlim=10.0
	ln=nl-1
c
c exit point specification from terminal
c
	write(*,10012)
10012	format(' Enter exit point (+6 to -6):',/)
	read(*,'(i2)') ixit
c	read (*,11012) jchar
c11012	format(a2)
c	decode(jchar,11112) jexit  --> invalid statement in IBM PROFORT
c11112	format(i2)
c	if(jexit.ne.0.and.iabs(jexit).le.6) ixit=jexit
	if(jprt.eq.ibl) go to 11013
c
c output file name specification from terminal
c
       	write(*,20012)
20012  	format(' Enter output file name:',/)
       	read (*,10002)dout
       	if(jopen.eq.1) close(20)
21112  	open (20,file=dout,status='new',form='formatted')
	jopen=1
c
c print input data
c
22012	write(20,13) ident,nm,ixit,nl,nv,escale,xscale,tscale,
     1 edat1,xdat1,edat2,xdat2,slope,a,blim,tlim,itrace,jjoff,idip
13	format (/,50x,13h** SIPT1 **  //,20a4,//,
     1     17hcontrol card data,
     2   13x,20hp l o t  s c a l e s,5x,9hd a t u m,4x,
     3   15ho v e r r i d e,
     4 	 4x,11hv a l u e s,/,30x,4helev,4x,5hhoriz,
     5	 3x,4htime,4x,29hp o i n t   1   p o i n t   2/1h ,5hsprds,2x,
     6	 44hexit  layers  vcards  ft/col  ft/row  ms/col,
     7	 2(3x,4helev,4x,5hx pos),3x,28hslope  intcpt   blim    tlim,3x,
     8	 13htrace off dip/1h ,5h-----,2x,4h----,13(2x,6h------),2x,
     9	 13h----- --- ---/1h ,i3,2i7,i8,2x,7f8.1,f8.4,f7.1,f8.2,f8.1,i6,
     1	 i5,i4)
11013  	if(jtrl.ne.ibl)write(*,10013) ident,nm,ixit,nl,nv,escale,
     1 xscale,tscale,edat1,xdat2,slope,a,blim,tlim,itrace,jjoff,idip,
     2 edat2,xdat2
10013	format(/30x,'** SIPT1 ** '//1x,20a4//' control card data'//
     1	' s x l v  ft/c  ft/r  ms/c edat1/2 xdat1/2  slope intcp blim  t
     2lim ',' t o d'/1x,i1,3i2,3f6.1,2f8.1,f7.4,f6.1,f5.2,f6.1,2x,3i2/,
     3  26x,2f8.1)
	nixit=0
	if(ixit.ge.0) go to 14
	ixit=iabs(ixit)
	nixit=1
14	if (nv.eq.0) go to 24
	if(jprt.eq.ibl) go to 11015
	write(20,15) (m,m=1,nm)
15	format (//,14hvelocity cards,//,4x,5(6x,'spread',i2))
	write(20,10014) (ibl,m=1,nm)
10014	format(2x,'layer',5(a1,'   vv     vh  '))
	write(20,11014) (ibl,m=1,nm)
11014	format(2x,'-----',5(a1,'------ ------'))
11015	if(jtrl.eq.ibl) go to 10016
	write(*,10015)(m,m=1,nm)
10015	format(' velocity cards'//5(6x,'spread',i2))
	write(*,11016) (ibl,m=1,nm)
11016	format(1x,'l',5(a1,'   vv     vh '))
10016	do 20 i=1,nv
c
c read velocity override card
c
	if(ifprint.eq.icee)read(10,17) l,(vva(m,l),vha(m,l),m=1,nm)
17	format (i1,10f6.0)
	if(ifprint.eq.itee) read(10,*) l,(vva(m,l),vha(m,l),m=1,nm)
	if(jprt.ne.ibl) write(20,19) l,(vva(m,l),vha(m,l),m=1,nm)
19	format (4x,i1,2x,10f7.0)
	if(jtrl.ne.ibl)write(*,10019)l,(vva(m,l),vha(m,l),m=1,nm)
10019	format(1x,i1,10f7.0)
	do 20 m=1,nm
	vva(m,l)=vva(m,l)/1000.
	vha(m,l)=vha(m,l)/1000.
20	continue
24	ity=ibl
	if(jtrl.eq.ibl) go to 25
c
c sp & geo data table specification from terminal
c
 	write(*,22)
22	format(//
     1' Table of sp & geo data? (t to type, <cr> to suppress):'/)
	read (*,10006)ity
c
c read spread control card
c
25	do 60 m=1,nm
	if(ifprint.eq.icee) read(10,27) idspr(m),nj(m),nk(m),xshift(m),
     1 ixtrue
27	format (a1,2i3,f11.1,1x,i1)
	if(ifprint.eq.itee) read(10,*) idspr(m),nj(m),nk(m),xshift(m),
     1 ixtrue
	if(jprt.ne.ibl)write(20,29) idspr(m),nj(m),nk(m),xshift(m),
     1   ixtrue
29	format(//28h shotpoint and geophone data//2x,6hspread,1x,a1,1h,,
     1	i2,1x,11hshotpoints,,i3,1x,19hgeophones, xshift =,f8.1,
     2  9h, xtrue =,i2//2x,
     3  55hsp   elev     x loc    y loc    depth uphole t  fudge t,
     1  2x,6hend sp/2x,10h-- -------,6(1x,8h--------))
	if(jtrl.ne.ibl.and.ity.ne.ibl)write(*,29)idspr(m),nj(m),nk(m),
     1 xshift(m),ixtrue
	xlast=-big
	jn=nj(m)
c
c read shotpoint control cards
c
	do 35 j=1,jn
	if(ifprint.eq.icee) read(10,31) idtest,idsp(j,m),esp(j,m),
     1 xsp(j,m),ysp(j,m),zsp(j,m),tuh(j,m),tfudge(j,m),jc
31	format (a1,2x,a1,3f7.1,3f5.1,1x,i1)
	if(ifprint.eq.itee) read(10,*) idsp(j,m),esp(j,m),
     1 xsp(j,m),ysp(j,m),zsp(j,m),tuh(j,m),tfudge(j,m),jc
	if (xsp(j,m).lt.xlast) go to 9990
	if(ifprint.eq.icee.and.idtest.ne.idspr(m)) go to 9990
	if(jprt.ne.ibl) write(20,33) idsp(j,m),esp(j,m),xsp(j,m),
     1 ysp(j,m),zsp(j,m),tuh(j,m),tfudge(j,m),jc
33	format (1h ,2x,a1,f8.1,5f9.1,i6)
	if(jtrl.ne.ibl.and.ity.ne.ibl)write(*,33)idsp(j,m),esp(j,m),
     1 xsp(j,m),ysp(j,m),zsp(j,m),tuh(j,m),tfudge(j,m),jc
	es(j,m)=esp(j,m)-zsp(j,m)
	if (jc.eq.1) ja(m)=j
	if (jc.eq.2) jb(m)=j
	xlast=xsp(j,m)
35	continue
	if(jprt.eq.ibl) go to 10040
	write(20,41) (idsp(j,m),j=1,jn)
41	format (/,13x,
     1  46harrival times + fudge t and layers represented,
     2  //,30h  geo  elev     x loc    y loc,1x,7(5x,3hsp ,a1))
	write(20,42) (ibl,j=1,jn)
42	format('  --- ------',2(' --------'),2x,7(a2,'-------'))
10040	if(jtrl.eq.ibl.or.ity.eq.ibl) go to 10043
	write(*,10041)(idsp(j,m),j=1,jn)
10041	format(/13x,46harrival times + fudge t and layers represented,
     1  //,1x,21h g  elev      x   y  ,7(3x,3hsp ,a1))
	write(* ,10042) (ibl,j=1,jn)
10042	format('  - ------ ------ --- ',7(a1,'------'))
10043	xlast=-big
	kn=nk(m)
c
c read geophone control card data
c
	do 55 k=1,kn
	if(ifprint.eq.icee) read(10,43) idtest,ktest,eg(k,m),xg(k,m),
     1 yg(k,m),(ta(k,j,m),lg(k,j,m),j=1,jn)
43	format (a1,i3,3f7.1,7(f5.1,1x,i1))
	if(ifprint.eq.itee) read(10,*) ktest,eg(k,m),xg(k,m),
     1 yg(k,m),(ta(k,j,m),lg(k,j,m),j=1,jn)
	if(ktest.ne.k.or.xg(k,m).lt.xlast) go to 9990
	do 44 j=1,jn
	if (ta(k,j,m).ne.0.0) ta(k,j,m)=ta(k,j,m)+tfudge(j,m)
	if (ta(k,j,m).le.0.) lg(k,j,m)=0
	tr(k,j,m)=ta(k,j,m)
44	continue
	if(jprt.ne.ibl)write(20,45) k,eg(k,m),xg(k,m),yg(k,m),
     1 (ta(k,j,m),lg(k,j,m),j=1,jn)
45	format (2x,i2,f8.1,2f9.1,2x,7(f7.1,i2))
	if(jtrl.ne.ibl.and.ity.ne.ibl)write(*,10045)k,eg(k,m),xg(k,m),
     1 yg(k,m),(ta(k,j,m),lg(k,j,m),j=1,jn)
10045	format(1x,i2,2f7.0,f4.0,1x,7(f5.0,i2))
	xlast=xg(k,m)
55	continue
	if((m.ne.nm.or.nixit.eq.0).and.jprt.ne.ibl)write(20,57) ident
57	format (///,20a4)
60	continue
c
c the following routine (lines 60 -95) corresponds to SIPT rev22.
c (rev23 contains a different algorithm).
c
c if ixtrue=0, correct x-distances.  ixtrue=0 implies that x-distances
c for sps & geos are measured along ground surface and no correction has
c been made for slope.
c
	if(ixtrue.ne.0) go to 95
	do 90 m=1,nm
	jn=nj(m)
	kn=nk(m)
	xs(1)=xg(1,m)
	do 62 k=2,kn
	xs(k)=xs(k-1)+sqrt((xg(k,m)-xg(k-1,m))**2-(eg(k,m)-eg(k-1,m))**2)
62	continue
	do 64 j=1,jn
	if(xsp(j,m).gt.xg(1,m)) go to 66
64	continue
	j=jn+1
66	j1=j-1
	if(j1.eq.0) go to 70
	xtie=xs(1)
	xref=xg(1,m)
	eref=eg(1,m)
	do 68 j=1,j1
	jr=j1-j+1
	xtie=xtie-sqrt((xref-xsp(jr,m))**2-(eref-esp(jr,m))**2)
	xref=xsp(jr,m)
	eref=esp(jr,m)
	xsp(jr,m)=xtie
68	continue
70	j1=j1+1
	do 72 j=j1,jn
	if(xsp(j,m).gt.xg(kn,m)) go to 74
	do 71 k=2,kn
	if(xg(k,m).lt.xsp(j,m)) go to 72
	xsp(j,m)=xs(k-1)+(xs(k)-xs(k-1))*(xsp(j,m)-xg(k-1,m))/
     1	(xg(k,m)-xg(k-1,m))
71	continue
72	continue
	go to 78
74	j1=j
	xtie=xs(kn)
	xref=xg(kn,m)
	eref=eg(kn,m)
	do 76 j=j1,jn
	xtie=xtie+sqrt((xsp(j,m)-xref)**2-(esp(j,m)-eref)**2)
	xref=xsp(j,m)
	eref=esp(j,m)
	xsp(j,m)=xtie
76	continue
78	do 80 k=1,kn
80	xg(k,m)=xs(k)
90	continue
c
c compute v1 using direct dist dd from shot to geos for which lg=1
c
95     	if(nixit.eq.0)then
	if ((jprt.eq.ix).and.(jtrl.eq.ix))then
       	   write(20,100)
      	   write(*,100)
      	elseif((jprt.eq.ix).and.(jtrl.eq.ibl))then
       	   write(20,100)
       	elseif((jprt.eq.ibl).and.(jtrl.eq.ix))then
       	   write(*,100)
       	endif
       	endif
c
100	format (//,2x,42hv1 for direct rays and direct distances dd)
	sum1=0.0
	pts1=0.0
	do 150 m=1,nm
	sum2=0.0
	pts2=0.0
	jn=nj(m)
	do 120 j=1,jn
	sum3=0.0
	pts3=0.0
	kn=nk(m)
	do 110 k=1,kn
	if (lg(k,j,m).ne.1) go to 110
	d(k,j,m)=sqrt ((eg(k,m)-es(j,m))**2+(xg(k,m)-xsp(j,m))**2+
     1	(yg(k,m)-ysp(j,m))**2)
	vdd(k,j,m)=d(k,j,m)/ta(k,j,m)
	pts3=pts3+1.0
	sum3=sum3+vdd(k,j,m)
	pts2=pts2+1.0
	sum2=sum2+vdd(k,j,m)
	pts1=pts1+1.0
	sum1=sum1+vdd(k,j,m)
110	continue
	if (pts3.eq.0.) go to 115
	avvdd(j)=sum3/pts3
	go to 120
115	avvdd(j)=0.0
120	continue
	if (pts2.eq.0.) go to 126
	sum2=sum2/pts2
126	if (nixit.eq.1) go to 150
       	if((jprt.eq.ix).and.(jtrl.eq.ix))then
          write(20,130) idspr(m)
          write(*,130)  idspr(m)
       	elseif((jprt.eq.ix).and.(jtrl.eq.ibl))then
          write(20,130) idspr(m)
       	elseif((jprt.eq.ibl).and.(jtrl.eq.ix))then
          write(*,130)  idspr(m)
       	endif
130	format(/,2x,'spread',1x,a1,5x,'sp  geo    dd       v1   avg v1',
     1/,15x,'--  ---',3('  ------'))
	do 140 j=1,jn
	do 134 k=1,kn
	if(vdd(k,j,m).eq.0.) go to 134
       	if((jprt.eq.ix).and.(jtrl.eq.ix))then
 	  write(20,132) idsp(j,m),k,d(k,j,m),vdd(k,j,m)
       	  write(*,132)  idsp(j,m),k,d(k,j,m),vdd(k,j,m)
       	elseif((jprt.eq.ix).and.(jtrl.eq.ibl))then
       	  write(20,132) idsp(j,m),k,d(k,j,m),vdd(k,j,m)
       	elseif((jprt.eq.ibl).and.(jtrl.eq.ix))then
       	  write(*,132)  idsp(j,m),k,d(k,j,m),vdd(k,j,m)
       	endif
c
132	format(16x,a1,i5,f8.1,3pf8.0)
134	continue
	if(avvdd(j).ne.0.) then
       	if((jprt.eq.ix).and.(jtrl.eq.ix))then
       	  write(20,136) avvdd(j)
       	  write(*,136)  avvdd(j)
       	elseif((jprt.eq.ix).and.(jtrl.eq.ibl))then
       	  write(20,136) avvdd(j)
	elseif((jprt.eq.ibl).and.(jtrl.eq.ix))then
       	  write(*,136)  avvdd(j)
       	endif
       	endif
136	format(38x,3pf8.0)
140	continue
150	continue
	if (pts1.eq.0.) go to 152
	sum1=sum1/pts1
152	vreg(1)=sum1
	if (vreg(1).le.0.0) vreg(1)=1.5
156	if (nixit.eq.0)then
       	   if((jprt.eq.ix).and.(jtrl.eq.ix))then
       	         write(20,157) sum1
       	         write(*,157)  sum1
       	   elseif((jprt.eq.ix).and.(jtrl.eq.ibl))then
       	         write(20,157) sum1
      	   elseif((jprt.eq.ibl).and.(jtrl.eq.ix))then
       	         write(*,157)  sum1
       	   endif
       	endif
157	format(27x,'  avg of all',3pf7.0,/,27x,'  -----------------',/)
c
c apply xshift to xsp and xg arrays
c also compute dir dist between (xsp,ysp,esp) and (xg,yg,eg) if
c lg.ne.1 and compute plot positions p
c
	do 180 m=1,nm
	jn=nj(m)
	kn=nk(m)
	do 165 k=1,kn
	xg(k,m)=xg(k,m)+xshift(m)
165	continue
	do 175 j=1,jn
	xsp(j,m)=xsp(j,m)+xshift(m)
	do 170 k=1,kn
	if (lg(k,j,m).ne.1) d(k,j,m)=sqrt((xg(k,m)-xsp(j,m))**2+(yg(k,m)-
     1 ysp(j,m))**2+(eg(k,m)-esp(j,m))**2)
	if (xg(k,m)-xsp(j,m)) 168,166,167
166	if (k.eq.kn) go to 168
167	p(k,j,m)=xsp(j,m)+d(k,j,m)
	go to 170
168	p(k,j,m)=xsp(j,m)-d(k,j,m)
170	continue
175	continue
180	continue
c
c find number of geo to the left, kl(j,m), and right, kr(j,m) of each sp.
c if none, kl or kr set to zero.
c
	do 188 m=1,nm
	jn=nj(m)
	kn=nk(m)
	do 186 j=1,jn
	if (xsp(j,m).le.xg(1,m)) go to 183
	if (xsp(j,m).ge.xg(kn,m)) go to 184
	do 181 k=2,kn
	if (xg(k,m).gt.xsp(j,m)) go to 182
181	continue
182	kl(j,m)=k-1
	kr(j,m)=k
	go to 186
183	kl(j,m)=0
	kr(j,m)=1
	go to 186
184	kl(j,m)=kn
	kr(j,m)=0
186	continue
188	continue
c
c find end sps for each spread and set limits of x axis for t-d graph
c
	xsco2=xscale/2.0
       	if(jjoff.ne.0) go to 201
	do 200 m=1,nm
	jn=nj(m)
	kn=nk(m)
	if (ja(m).ne.0) go to 192
	do 190 j=1,jn
	if (xsp(j,m).le.xg(1,m)) go to 190
	ja(m)=j-1
	if (j.gt.1) go to 192
	ja(m)=1
	if (m.eq.1) xlim1=xg(1,1)
	go to 194
190	continue
	ja(m)=jn
192	if (m.ne.1) go to 195
	j=ja(m)
	xlim1=amin1(xsp(j,1),xg(1,1))
194	xlim1=xlim1+xsco2
195	if (jb(m).ne.0) go to 197
	do 196 j=1,jn
	if (xsp(j,m).lt.xg(kn,m)) go to 196
	jb(m)=j
	go to 197
196	continue
	jb(m)=jn
	if (m.ne.nm) go to 200
	xlim2=xg(kn,nm)
	go to 200
197	if (m.ne.nm) go to 200
	j=jb(m)
	xlim2=amax1(xsp(j,nm),xg(kn,nm))
200	continue
       	go to 203
201    	do 202 m=1,nm
       	jn=nj(m)
       	ja(m)=1
202    	jb(m)=jn
       	xlim1=xsp(1,1)
       	xlim2=xsp(jn,nm)
c
c t-d plot selection from terminal
c
203	iplot=0
	if(nixit.eq.1) go to 204
	write(*,10200)
10200	format(/
     1' T-D plot? (0=no plot, 1=raw, 2=datum, 3=pre-d, 4=l1 remvd):',/)
	read (*,*) iplot
c
c test for doing raw time t-d plot
c
10204	if(iplot.eq.1) call plot(1)
204	if (ixit.eq.0) go to 1
c
c fit straight line thru geo elevations
c
205	if (slope.ne.0.0.or.a.ne.0.0) go to 225
	if (xdat1.ne.0.0.or.xdat2.ne.0.0) go to 220
	sum1=0.0
	sum2=0.0
	pts=0.0
	do 212 m=1,nm
	kn=nk(m)
	do 210 k=1,kn
	sum1=sum1+xg(k,m)
	sum2=sum2+eg(k,m)
	pts=pts+1.0
210	continue
212	continue
	xbar=sum1/pts
	ebar=sum2/pts
	sum1=0.0
	sum2=0.0
	do 216 m=1,nm
	kn=nk(m)
	do 214 k=1,kn
	diff=xg(k,m)-xbar
	sum1=sum1+diff*eg(k,m)
	sum2=sum2+diff**2
214	continue
216	continue
	slope=sum1/sum2
	a=ebar-slope*xbar
	go to 225
220	slope=(edat2-edat1)/(xdat2-xdat1)
	a=edat1-slope*xdat1
225	do 230 m=1,nm
	kn=nk(m)
	do 226 k=1,kn
	edg(k,m)=a+slope*xg(k,m)
226	continue
	jn=nj(m)
       	do 228 j=1,jn
	edsp(j,m)=a+slope*xsp(j,m)
228	continue
230	continue
c
c velocity override card analysis -- set any zero vh=vv if vv nonzero
c
	iover=0
	if (vva(1,1).ne.0.0) go to 242
	do 240 m=1,nm
	vva(m,1)=vreg(1)
240	continue
	go to 246
242	iover=1
	if (nm.le.1) go to 246
	do 244 m=2,nm
	if (vva(m,1).eq.0.0) vva(m,1)=vva(1,1)
244	continue
246	do 248 m=1,nm
	do 247 l=2,nl
	if (vva(m,l).eq.0.0) go to 247
	if (vha(m,l).eq.0.0) vha(m,l)=vva(m,l)
247	continue
248	continue
	if (nm.le.1) go to 300
	do 250 l=2,nl
	do 249 m=2,nm
	if (vva(m,l).eq.0.0) vva(m,l)=vva(m-1,l)
	if (vha(m,l).eq.0.0) vha(m,l)=vha(m-1,l)
249	continue
250	continue
c
c compute and apply vertical time corrections to datum -- print results
c
300	if(nixit.eq.1) go to 303
	if(jtrl.eq.ibl) go to 301
	write(*,10303)vreg(1)
10303	format(/1x,'computed v1 =',3pf8.0/)
	if(iover.eq.0) go to 301
	if(nm.gt.1) write(*,10304) (m,m=1,nm)
10304	format(6x,'spread',5(i8))
	write(*,10305) (vva(m,1),m=1,nm)
	write(*,10301)
10305	format(1x,'override v1 =',5(3pf8.0))
301	if(jprt.eq.ibl) go to 303
	if(iover.eq.0) go to 10302
	if(nm.gt.1) write(20,10304) (m,m=1,nm)
	write(20,10305) (vva(m,1),m=1,nm)
	write(20,10301)
10301	format(1x,7('--------'))
10302	write(20,57) ident
	write(20,302) a, slope
302	format (//,46harrival times corrected to datum (datum elev =,
     1  f8.1,4h + (,f8.4,25h)x), and plot positions d)
303	do 400 m=1,nm
	vv=vva(m,1)
	jn=nj(m)
	kn=nk(m)
c first precompute geo time corr
	do 304 k=1,kn
	tvg(k)=(edg(k,m)-eg(k,m))/vv
304	continue
c then compute sp time corr
	do 306 j=1,jn
	tvs(j)=0.
	if (j.lt.ja(m).or.j.gt.jb(m)) go to 306
	tvs(j)=(edsp(j,m)-es(j,m))/vv
	if (tuh(j,m).ne.0.0) tvs(j)=tvs(j)*tuh(j,m)*vv/zsp(j,m)
306	continue
c apply datum corrections
312	do 332 j=1,jn
	do 330 k=1,kn
	if (lg(k,j,m).ne.1.and.tr(k,j,m).ne.0.0) ta(k,j,m)=tr(k,j,m) +
     1 tvs(j) + tvg(k)
330	continue
332	continue
c
c print results
c
	if (nixit.eq.1.or.jprt.eq.ibl) go to 400
	write(20,383) idspr(m),(idsp(j,m),j=1,jn)
383	format (//,1x,7hspread ,a1,8x,7(10x,'sp ',a1))
	write(20,384) (edsp(j,m),j=1,jn)
384	format(/7x,'elev . . . . .',7(f10.1,4x))
	write(20,385) (tvs(j),j=1,jn)
385	format (9x,1h./9x,1h.,3x,6hcorr t,7(f12.1,2x))
	write(20,387) (ibl,j=1,jn)
387	format (' geo     .',10x,7(a1,'---t-----d---'))
	do 390 k=1,kn
	write(20,389) k,edg(k,m),tvg(k),(ta(k,j,m),p(k,j,m),j=1,jn)
389	format (1x,i2,2f8.1,1x,14f7.1)
390	continue
400	continue
c
c plot t-d graph
c
450	if(iplot.eq.2) call plot(1)
c
c exit point test and branch
c
	if (ixit.eq.1) go to 1
22222 	call part2
       	if(begin.eq.'y')go to 1
       	call part3
       	if(enter2.eq.'y')go to 22222
       	if(begin.eq.'y')go to 1
c
9990	if(jprt.ne.ibl)write(20,9991)
9991	format (/,
     1' Error on input cards, computation halted.  See documentation.'/)
	if(jtrl.ne.ibl)write(*,9991)
	go to 1
9999   	stop
	end
