c ************************ S1.FOR **************************************
c
c Program SIPT1.FOR -- version 1.0 -- USGS, Hartford, CT -- 08-15-86
c
c Micro-computer implementation of sipt22.fortran (on Denver PRIME).
c Compiled on an IBM PC using the IBM Professional FORTRAN compiler
c (version 1.0).
c Program consists of 9 modules: MAIN.FOR, PART2.FOR, PART3.FOR,
c INITIAL.FOR, S1.FOR, S2.FOR, S3.FOR, S4.FOR and S5.FOR.
c
c *********** beginning of subroutines *********************************
c
c ***** subroutine TIE (#1).  Written 09/06/81  1445.3rew **************
c makes tie correction for outlying sp jj to next inner sp j
	subroutine tie(l2,m,j,jj,k11,k22,kt1,kt2,kn,i,jjtie)
	character*1 ibl,iques,ip,it,icoln,iplus,isq,idash,is,iast,idee
     1 ,il,idspr,idsp
	common ibl,iques,ip,it,icoln,iplus,isq,idash,is,iast,idee,il
	common/ibm1/nl
	common/blk0/lg
	common/blk3/ta,tr,dsg
	common/blk4/vva,vha
	common/blk5/idspr,idsp
	common/ibm3/kl,kr,d
	dimension lg(48,7,5),ta(48,7,5),dsg(48),tr(48,7,5),d(48,7,5),
     1	ip(103),it(53),il(5),idspr(5),idsp(7,5),kl(7,5),kr(7,5),vva(5,5)
     2	,vha(5,5)
c
	call kends(l2,m,j,kt1,kt2,kt11,kt22)
	if (kt11.eq.0) go to 99
	do 10 k=1,kn
10	dsg(k)=abs(d(k,j,m))
	sum1=0.
	pts1=0.
	k1=max0(k11,kt11)
	k2=min0(k22,kt22)
	if(k2.lt.k1) go to 50
c
c overlap between j and jj arrivals
c
20	do 30 k=k1,k2
	if (lg(k,jj,m).ne.l2) go to 30
	sum1=sum1+tr(k,jj,m)-tr(k,j,m)
	pts1=pts1+1.
30	continue
	if (pts1.eq.0.) go to 50
	sum1=sum1/pts1
35	do 40 k=k11,k22
	if (lg(k,jj,m).eq.l2) tr(k,jj,m)=tr(k,jj,m)-sum1
40	continue
	if(jjtie.eq.0) go to 60
	if(i.eq.2) go to 44
	kk=k22+1
	if(kk.gt.kn) go to 99
	do 42 k=kk,kn
	if(tr(k,jj,m).ne.0) tr(k,jj,m)=tr(k,jj,m)-sum1
42	continue
	go to 99
44	kk=k11-1
	if(kk.lt.1) go to 99
	do 46 k=1,kk
	if(tr(k,jj,m).ne.0) tr(k,jj,m)=tr(k,jj,m)-sum1
46	continue
       	go to 99
c
c gap between j and jj arrivals
c
50	call regres(kt11,kt22,j,m,l2,vj,tj,pt,1)
	if(pt.eq.0.) go to 99
	call regres(k11,k22,jj,m,l2,vjj,tjj,pt,1)
	if(pt.eq.0.) go to 99
	if(i.eq.2) go to 54
	dmid=(dsg(k22)+dsg(kt11))/2
52	sum1=(tjj+tjj+dmid/vjj)-(tj+tj+dmid/vj)
	go to 35
54	dmid=(dsg(k11)+dsg(kt22))/2
	go to 52
c
c tie down points for deeper layers l2+1 thru nl (sp jj)
c
60	lnext=l2+1
	if(lnext.gt.nl) go to 99
	dt1=sum1
	do 80 l=lnext,nl
	l1=l-1
	dt2=dt1*vha(m,l1)/vha(m,l)
	do 70 k=1,kn
	if(lg(k,jj,m).eq.l) tr(k,jj,m)=tr(k,jj,m)-dt2
70	continue
	dt1=dt2
80	continue
	jjtie=1
99	return
	end
c
c
c ****** Function TERP.   written 09/06/81  1445.3rew ******************
c computes interpolated value of y corresponding to x, given the 2 pts
c (x1,y1) and (x2,y2)
c
	function terp(x1,y1,x2,y2,x)
	if (abs (x2-x1).lt.0.1) go to 2
      	terp=((x-x1)*(y2-y1))/(x2-x1)+y1
1 	return
2	terp=(y1+y2)/2.0
      	go to 1
      	end
c
c
c **** Subroutine SETIP (#2).  written 09/06/81  1445.3rew *************
c sets print for line of depth pt graph
c
	subroutine setip(e,emin,escale,isym)
	character*1 ibl,iques,ip,it,icoln,iplus,isq,idash,isym,ipi,iti
	common ibl,iques,ip,it,icoln,iplus,isq,idash
	dimension ip(103),it(53)
c
	i=2+ifix ((e-emin)/escale+0.5)
	ii=(i-2)/2+2
	if (i.gt.0) go to 1
	i=1
	ii=1
	go to 2
c
1	if (i.le.103) go to 2
	i=103
	ii=53
2	ipi=ip(i)
	iti=it(ii)
	if(ipi.eq.ibl.or.ipi.eq.icoln.or.ipi.eq.iplus.or.ipi.eq.idash)
     1 go to 4
	ip(i)=isq
	go to 6
4	ip(i)=isym
6	if(iti.eq.ibl.or.iti.eq.icoln.or.iti.eq.iplus.or.iti.eq.idash)
     1 go to 8
	it(ii)=isq
	go to 10
8	it(ii)=isym
10	return
	end
c
c
c Subroutine REGV (#3).  written 09/06/81  1446.7rew *******************
c computes and prints regression velocities and intercept t for layer l
c
	subroutine regv(l,nixit)
	character*1 ibl,jtrl,jprt,jvel,idspr,idsp,idum
	common ibl
	common/blk0/lg
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	common/blk3/ta,tr,dsg
	common/blk5/idspr,idsp
	common/ibm3/kl,kr,d
	common/blk11/vreg,preg
	dimension nj(5),nk( 5),kl(7,5),kr(7,5),d(48,7,5),idspr(5),
     1 idsp(7,5),vreg(5),preg(5),lg(48,7,5),ta(48,7,5),tr(48,7,5),
     2 dsg(48)
c
	if (nixit.eq.0.and.jprt.ne.ibl) write(20,1) l
1	format (' Layer',i2,' velocity and time intercepts computed by',
     1 ' regression')
	if(jvel.ne.ibl) write(*,1) l
	sum1=0.0
	pts1=0.0
	do 50 m=1,nm
	mcall=m
	none=0
	jn=nj(m)
	kn=nk(m)
	sum2=0.0
	pts2=0.0
	do 40 j=1,jn
	jcall=j
	call kends(l,mcall,jcall,1,kl(j,m),kl1,kl2)
	if (kl1.eq.0) go to 10
	do 5 k=kl1,kl2
	dsg(k)=d(k,j,m)
5	continue
	call regres(kl1,kl2,jcall,mcall,l,vl,tlf,pt,0)
	if (pt.le.1.0) go to 10
	tlf=tlf+tlf
	sum3=pt/vl
	pts3=pt
	go to 15
10	vl=0.0
	tlf=0.0
	sum3=0.0
	pts3=0.0
15	call kends(l,mcall,jcall,kr(j,m),kn,kr1,kr2)
	if (kr1.eq.0) go to 23
	do 20 k=kr1,kr2
	dsg(k)=d(k,j,m)
20	continue
	call regres(kr1,kr2,jcall,mcall,l,vr,trt,pt,0)
	if (pt.le.1.0) go to 23
	trt=trt+trt
	pts3=pts3+pt
	sum3=sum3+pt/vr
	go to 24
23	vr=0.0
	trt=0.0
	avgt=tlf
24	sum2=sum2+sum3
	pts2=pts2+pts3
	sum1=sum1+sum3
	pts1=pts1+pts3
	if (pts3.eq.0.0) go to 40
	if (tlf.eq.0.0) avgt=trt
	if (tlf.ne.0.0.and.trt.ne.0.0) avgt=(tlf+trt)/2.0
	if (none.ne.0) go to 27
	none=1
	if (nixit.eq.0.and.jprt.ne.ibl) write(20,25) idspr(m)
25	format (/8h spread ,a1/4x,22hvel   time   geos   sp,5x,
     1	 17hgeos  time    vel,8x,19havg v   avg t   pts/2x,6h------,
     2	 2x,4h----,2x,5h-----,3x,3h---,3x,5h-----,2x,4h----,2x,6h------,
     3	 6x,6h------,3x,5h-----,3x,3h---)
	if(jvel.ne.ibl) write(*,25) idspr(m)
27	sum3=pts3/sum3
	if (nixit.eq.1) go to 40
	if(jprt.ne.ibl) write(20,31) vl,tlf,kl1,kl2,idsp(j,m),kr1,kr2,
     1	trt,vr,sum3,avgt,pts3
31	format (1x,3pf7.0,0pf6.1,1x,2i3,4x,a1,3x,2i3,f6.1,3pf8.0,f12.0,
     1	 0pf8.1,f6.0)
	if(jvel.ne.ibl) write(*,31)vl,tlf,kl1,kl2,idsp(j,m),kr1,kr2,trt,
     1	vr,sum3,avgt,pts3
40	continue
c
	if (none.eq.0) go to 50
	sum2=pts2/sum2
	if (nixit.eq.1) go to 50
	if(jprt.ne.ibl) write(20,41) sum2,pts2
	if(jvel.ne.ibl) write(*,41)sum2,pts2
41	format (/51x,3havg,3pf7.0,0pf14.0)
42	format (/44x,10havg of all,3pf7.0,0pf14.0)
50	continue
c
	if (pts1.eq.0.0) go to 56
	vreg(l)=pts1/sum1
	preg(l)=pts1
	if (nm.eq.1.or.nixit.eq.1) go to 60
	if(jprt.ne.ibl) write(20,55)
55	format (/55x,7h-------,10x,3h---)
	if(jprt.ne.ibl) write(20,42) vreg(l),pts1
	if(jvel.eq.ibl) go to 60
	write(*,55)
	write(*,42)vreg(l),pts1
	go to 60
56	vreg(l)=0.0
	preg(l)=0.0
c
	if (nixit.eq.0.and.jprt.ne.ibl) write(20,57)
57	format(//,8h--none--)
	if(jvel.ne.ibl) write(*,57)
60	return
	end
c
c
c ***** Subroutine HOBV (#4).  Written 09/06/81  1446.7rew *************
c computes horiz vel of layer l by hobson-overton method
c
	subroutine hobv(l,nixit)
	character*1 ibl,jtrl,jprt,idspr,idsp,jvel,idum
	common ibl
	common/blk0/lg
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	common/blk3/ta,tr,dsg
	common/blk5/idspr,idsp
	common/ibm3/kl,kr,d
	common/blk12/vhob,phob
	dimension ep(48),dx(48),dt(48),nj(5),nk(5),idspr(5),lg(48,7,5),
     1	 ta(48,7,5),kr(7,5),kl(7,5),idsp(7,5),vhob(5),phob(5),d(48,7,5),
     2	 dsg(48),ki(5),pe(5),tr(48,7,5)
c
	if (nixit.eq.0.and.jprt.ne.ibl) write(20,2) l
2	format (//,' Layer',i2,' velocity computed by hobson-overton',
     1 ' method')
	if(jvel.ne.ibl) write(*,2)l
	sum2=0.0
	pts2=0.0
c
	do 22 m=1,nm
	mcall=m
	none=0
	jn=nj(m)
	kn=nk(m)
	sum3=0.0
	pts3=0.0
	j2=jn-1
c
	do 18 j=1,j2
	jcall=j
	call kends(l,mcall,jcall,kr(j,m),kn,kr1,kr2)
	if (kr1.eq.0) go to 18
	j1=j+1
c
	do 16 jj=j1,jn
	jjcall=jj
	call kends(l,mcall,jjcall,1,kl(jj,m),kl1,kl2)
	k1=max0(kr1,kl1)
	k2=min0(kr2,kl2)
	if (kl1.eq.0.or.(k2-k1).le.0) go to 16
c
c begin hobson-overton routine
c
	sdx=0.0
	sdx2=0.0
	sdt=0.0
	sdtdx=0.0
	seep=0.0
	pt=0.0
	do 3 k=1,12
	ep(k)=0.0
3	continue
	do 4 k=k1,k2
	if (lg(k,j,m).ne.l.or.lg(k,jj,m).ne.l) go to 4
	dx(k)=abs(d(k,j,m))-abs(d(k,jj,m))
	sdx=sdx+dx(k)
	sdx2=sdx2+dx(k)**2
	dt(k)=ta(k,j,m)-ta(k,jj,m)
	sdt=sdt+dt(k)
	sdtdx=sdtdx+dx(k)*dt(k)
	pt=pt+1.0
4	continue
	if (pt.le.1.0) go to 9
	v=(sdx2-sdx**2/pt)/(sdtdx-(sdx*sdt)/pt)
	tdsp=(sdt-sdx/v)/pt
	do 6 k=k1,k2
	if (lg(k,j,m).ne.l.or.lg(k,jj,m).ne.l) go to 6
	ep(k)=dt(k)-dx(k)/v-tdsp
	seep=seep+ep(k)**2
6	continue
	seep=sqrt (seep/pt)
	do 8 ik=1,5
	ki(ik)=0
	pe(ik)=0.
	do 7 k=k1,k2
	if(abs(ep(k)).le.abs(pe(ik))) go to 7
	pe(ik)=ep(k)
	ki(ik)=k
7	continue
	if(ki(ik).eq.0) go to 8
	k=ki(ik)
	ep(k)=0.
8	continue
	go to 10
9	v=0.0
	pt=0.0
c
c end hobson-overton routine
c
10	if (pt.eq.0.0) go to 16
	sum3=sum3+v*pt
	pts3=pts3+pt
	if (nixit.eq.1) go to 16
	if (none.ne.0) go to 12
	if(jprt.ne.ibl) write(20,11) idspr(m)
11	format(/1x,' spread ',a1,39x,'5 highest eps'/7x,
     1    'vel   sps   geos',
     2	'  tdsp  se ep',5(4x,'ep   geo')/5x,'------',2x,
     3  '---  -----  ----',2x,'-----',5(3x,'---------'))
12	if(jprt.ne.ibl) write(20,13) v,idsp(j,m),idsp(jj,m),k1,k2,tdsp,
     1 seep,(pe(k),ki(k),k=1,5)
13	format (1x,3pf10.0,2x,a1,1x,a1,1x,2i3,0pf6.1,f7.3,5(f8.3,i4))
	if(jvel.eq.ibl) go to 19
	if(none.ne.0) go to 17
	write(*,14) idspr(m)
14	format(/1x,'spread ',a1,42x,'4 highest eps'/3x,
     1  'vel   sps   geos','  tdsp  se ep',4(4x,'ep   geo')/2x,
     2  '------',1x,'---  -----  ----',2x,'-----',4(3x,'---------'))
17	write(*,15) v,idsp(j,m),idsp(jj,m),k1,k2,tdsp,seep,
     1	(pe(k),ki(k),k=1,4)
15	format(1x,3pf7.0,1x,a1,1x,a1,1x,2i3,0pf6.1,f7.3,4(f8.3,i4))
19	none=1
16	continue
18	continue
c
	sum2=sum2+sum3
	pts2=pts2+pts3
	if (pts3.eq.0.0) go to 22
	sum3=sum3/pts3
	if (nixit.eq.0.and.jprt.ne.ibl) write(20,20) sum3,pts3
	if(jvel.ne.ibl) write(*,20)sum3,pts3
20	format (//,5x,'avg=',3pf7.0,' for',0pf5.0,' points')
22	continue
c
	if (pts2.eq.0.0) go to 26
	sum2=sum2/pts2
	if (nm.eq.1.or.nixit.eq.1) go to 28
	if(jprt.ne.ibl) write(20,25) sum2,pts2
	if(jvel.ne.ibl) write(*,25) sum2,pts2
25	format(//,1x,'avg of all=',3pf7.0,' for',0pf5.0,' points')
	go to 28
26	if(nixit.eq.0.and.jprt.ne.ibl) write(20,27)
	if(jvel.ne.ibl) write(*,27)
27	format(/3x,'not enough points')
c
28	vhob(l)=sum2
	phob(l)=pts2
	return
	end
c
c
c ***** Subroutine REGRES (#5).  Written 09/06/81  1446.7rew ************
c computes velocity v by regression of time pts (ta) at distances d from
c sp j to geos between indices k1 and k2 for layer l, spread m.
c only nonzero ta for which lg=l are used in regression.
c half intercept time at sp j is given by t, num of regressed pts is pt.
c
	subroutine regres(k1,k2,j,m,l,v,t,pt,it)
	common/blk0/lg
	common/blk3/ta,tr,d
	common/blk4/vva,vha
	dimension d(48),ta(48,7,5),tr(48,7,5),lg(48,7,5),vha(5,5),
     1 vva(5,5),tar(48)
c
	if(it.eq.1) go to 2
	do 1 k=k1,k2
1	tar(k)=ta(k,j,m)
	go to 4
2	do 3 k=k1,k2
3	tar(k)=tr(k,j,m)
4	s1=0.0
	s2=0.0
	pt=0.0
	t=0.0
	v=0.0
	do 5 k=k1,k2
	if (lg(k,j,m).ne.l) go to 5
	s1=s1+d(k)
	s2=s2+tar(k)
	pt=pt+1.0
5	continue
c
	if (pt.le.1.0) go to 15
	xbar=s1/pt
	tbar=s2/pt
	s1=0.0
	s2=0.0
	do 10 k=k1,k2
	if (lg(k,j,m).ne.l) go to 10
	xd=d(k)-xbar
	s1=s1+xd*tar(k)
	s2=s2+xd**2
10	continue
	v=abs (s2/s1)
	t=(tbar-xbar*s1/s2)/2.0
12	return
c
15	if (pt.eq.0.0) go to 12
	v=vha(m,l)
	if (v.le.0.0) go to 12
	t=(s2-s1/v)/2.0
	go to 12
	end
