c ************************ S2.FOR ************************************
c
c Program SIPT1.FOR -- version 1.0 -- USGS, Hartford, CT -- 08-15-86
c
c Micro-computer implementation of sipt22.fortran (on Denver PRIME).
c Compiled on an IBM PC using the IBM Professional FORTRAN compiler
c (version 1.0).
c Program consists of 9 modules: MAIN.FOR, PART2.FOR, PART3.FOR,
c INITIAL.FOR, S1.FOR, S2.FOR, S3.FOR, S4.FOR and S5.FOR.
c
c *********** subroutines resumes **************************************
c
c ****** Subroutine RAYUP (#6).  Written 09/06/81  1446.7rew ***********
c traces ray from starting point on top of layer l or ll to ending point
c (x0,e0) within or on the upper boundary of layer l0.  refracting horiz
c is the top of layer l.  computes and returns corrected coord of start
c point and total travel time. for irep=1, ll=l-1, and ray start point
c is taken as (xll,ell) on top of layer ll,  for irep=2 or 3, ll=l, and
c start point is taken as (xl,el) on top of layer l. also for irep=2 or
c 3, ray intersection with top of layer l-1 is outputted as (xll,ell)
c and time from this point as tll. input parameter bll is precomputed
c as avg dip of refractor over entire spread. if bll is nonzero on input
c it is used in place of interval dip between  geo pairs which is
c otherwise computed internally. input parameter i is preset to 1 for
c rays going up and right, 2 for rays going up and left.
c for the case where shot is below refractor (es(j,m).lt.ers(j,m,l1)),
c tll=big on input and ray is traced from shot to geo.
c
	subroutine rayup(l,ll,l0,j,m,i,x0,e0,xll,ell,tll,xl,el,tl,bll)
	character*1 ibl,jtrl,jprt,jvel,idum
	character*12 ipath
	common ibl
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	common/blk2/xg,erp,slope,idip
	common/blk4/vva,vha
	common/blk6/trp,jjoff
	common/blk7/ja,jb,trs,ers,xsp,esp,ls
	common/blk9/eg,es
	common/blk10/blim,itrace,tansg
       	dimension nk(5),xg(48,5),erp(48,5,4),vva(5,5),vha(5,5),nj(5),
     1   ja(5),jb(5),trs(7,5,4),ers(7,5,4),xsp(7,5),esp(7,5),ls(7,5),
     2   es(7,5),eg(48,5),trp(48,5,4)
	data big,small/999999.,0.000001/
c
	none=0
	xlls=xll
	tlls=tll
	xls=xl
	tls=tl
	if (l.eq.ll) xll=xl
2	iblsw=0
3	xrefl=xll
	xrefll=xll
	tll=0.0
	tl=0.0
	m1=m
	l2=ll
	l1=l2-1
c compute slope of ray from starting point
	inval=0
	mflag=0
	if(bll.ne.0.) bl=bll
c first find k of geos bounding xll
4	kn=nk(m1)
	k3=kn-1
	k1=1
	k2=2
	if (xll.lt.xg(1,m1)) go to 8
	k1=kn-1
	k2=kn
	if (xll.gt.xg(kn,m1)) go to 11
	do 6 k1=1,k3
	k2=k1+1
	if (xll.le.xg(k2,m1)) go to 15
6	continue
	go to 14
c case of xll left of spread m1
8	if (m1.eq.1) go to 9
	if (inval.gt.0) go to 15
	inval=-1
	m1=m1-1
	go to 4
c case of xll left of spread 1
9	if(bll.ne.0..or.idip.ne.0) go to 10
	kmid=kn/2
	k1=1
	k2=2
	if(kmid-k1.lt.5) kmid=k1+5
	if(kmid.gt.kn) kmid=kn
	call dip(l1,m1,k1,kmid,k1,a,bl)
10	if(jjoff.eq.0) go to 310
	j2=ja(1)
	if(xll.ge.xsp(j2,1).or.j2.le.1) go to 310
110	j1=j2-1
	if(xll.ge.xsp(j1,1).or.j1.eq.1) go to 210
	j2=j2-1
	go to 110
210	ell=terp(xsp(j1,1),ers(j1,1,l1),xsp(j2,1),ers(j2,1,l1),xll)
	go to 410
310	if(idip.ne.0.and.bll.eq.0.) bl=slope
	if(bl.gt.blim) bl=blim
	if(bl.lt.-blim) bl=-blim
	ell=erp(k1,m1,l1)+bl*(xll-xg(k1,m1))
410	mflag=1
	go to 16
c case of xll right of spread m1
11	if (m1.eq.nm) go to 12
	if (inval.lt.0) go to 15
	inval=1
	m1=m1+1
	go to 4
c case of xll right of spread nm
12	if(bll.ne.0..or.idip.ne.0) go to 13
	kmid=kn/2+1
	k1=kn-1
	k2=kn
	if(k2-kmid.lt.5) kmid=k2-5
	if(kmid.lt.1) kmid=1
	call dip(l1,m1,kmid,k2,k2,a,bl)
13	if(jjoff.eq.0) go to 313
	jn=nj(nm)
	j1=jb(nm)
	if(xll.le.xsp(j1,nm).or.j1.ge.jn) go to 313
113	j2=j1+1
	if(xll.le.xsp(j2,nm).or.j2.eq.jn) go to 213
	j1=j1+1
	go to 113
213	ell=terp(xsp(j1,nm),ers(j1,nm,l1),xsp(j2,nm),ers(j2,nm,l1),xll)
	go to 413
313	if(idip.ne.0.and.bll.eq.0.) bl=slope
	if(bl.gt.blim) bl=blim
	if(bl.lt.-blim) bl=-blim
	ell=erp(k2,m1,l1)+bl*(xll-xg(k2,m1))
413	mflag=2
	go to 16
14	k1=kn-1
	k2=kn
c k1, k2, and m1 now known. compute ell and bl for layer l1 at xll.
15	ell=terp(xg(k1,m1),erp(k1,m1,l1),xg(k2,m1),erp(k2,m1,l1),xll)
16	el=ell
	erefl=ell
	erefll=ell
	if (none.ne.0) go to 17
	ells=ell
	els=ell
17	if (bll.eq.0.0) go to 18
	bl=bll
	go to 19
18	if (iblsw.ne.0) go to 19
	denom=xg(k2,m1)-xg(k1,m1)
	if (denom.gt.0.1) go to 118
	bl=slope
	go to 19
118	if(mflag.ne.0) go to 119
	bl=(erp(k2,m1,l1)-erp(k1,m1,l1))/denom
119	if (bl.gt.blim) bl=blim
	if (bl.lt.-blim) bl=-blim
19	blref=bl
	if(tlls.lt.big) go to 219
c
c ray traced from es when es is below refractor.
c
	denom=sqrt(((xll-xsp(j,m))**2+(ell-es(j,m))**2)*(1.+bl**2))
	if(denom.lt.0.001) go to 219
	sinr=(ell-es(j,m)-bl*(xll-xsp(j,m)))/denom
	if(abs(sinr).gt.0.999) go to 219
	sini=sinr*vva(m1,l1)/vha(m1,l)
	tani=sini/sqrt(1.-sini**2)
	go to 120
219	tani=vva(m1,l1)/sqrt(vha(m1,l)**2-vva(m1,l1)**2)
c compute slope of ray emerging from l2
120	if (i.eq.2) tani=-tani
c entry pt for rays after 1st one
20	denom=tani-bl
c decrement l1 in preparation for finding intersection w/ horizon above
	l1=l1-1
	l2=l2-1
c vertical ray test
	if (abs(denom).lt.small) go to 39
c nonvertical ray
	bray=(tani*bl+1.0)/denom
	aray=ell-bray*xll
c test for uppermost ray -- if so compute xl1, tll, tl, and then exit
	if (l2.gt.l0) go to 23
	xl1=(e0-aray)/bray
	t=sqrt ((xl1-xll)**2+(e0-ell)**2)/vva(m1,l2)
	if (e0.gt.ell) go to 22
121	t=0.00001
21	l3=l2+1
	t=t*vva(m1,l2)/vva(m1,l3)
22	tll=tll+t
	tl=tl+t
	go to 46
c not uppermost ray -- compute tentative intersection w/ horizon above
23	inval=0
24	if(bll.ne.0.) go to 25
	denom=xg(k2,m1)-xg(k1,m1)
	if(denom.gt.0.1) go to 124
	bl=slope
	go to 25
124	if(mflag.eq.0) go to 125
	if(idip.eq.0) go to 224
	bl=slope
	go to 25
224	if(mflag.eq.2) go to 225
c mflag=1 (xll or xl1 left of spread m1)
324	kmid=kn/2
	k1=1
	k2=1
	if(kmid-k1.lt.5) kmid=k1+5
	if(kmid.gt.kn) kmid=kn
	call dip(l1,m1,k1,kmid,k1,a,bl)
	if(jjoff.eq.0.or.inval.eq.0) go to 25
	j2=ja(1)
	if(xl1.ge.xsp(j2,1).or.j2.le.1) go to 25
424	j1=j2-1
	if(xl1.ge.xsp(j1,1).or.j1.eq.1) go to 524
	j2=j1
	go to 424
524	bl=(ers(j2,m1,l1)-ers(j1,m1,l1))/(xsp(j2,m1)-xsp(j1,m1))
	go to 25
c mflag=2 (xll or xl1 right of spread m1)
225	kmid=kn/2+1
	k1=kn
	k2=kn
	if(k2-kmid.lt.5) kmid=k2-5
	if(kmid.lt.1) kmid=1
	call dip(l1,m1,kmid,k2,k2,a,bl)
	if(jjoff.eq.0.or.inval.eq.0) go to 25
	jn=nj(nm)
	j1=jb(nm)
	if(xl1.le.xsp(j1,nm).or.j1.ge.jn) go to 25
625	j2=j1+1
	if(xl1.le.xsp(j2,nm).or.j2.eq.jn) go to 524
	j1=j2
	go to 625
125	bl=(erp(k2,m1,l1)-erp(k1,m1,l1))/denom
25	if(bl.gt.blim) bl=blim
	if(bl.lt.-blim) bl=-blim
	al=erp(k1,m1,l1)-bl*xg(k1,m1)
c test for ray parallel with horizon above
	denom=bray-bl
	if (abs (denom).ge.small) go to 28
	if (bray) 32,26,36
26	go to (36,32), i
c test for valid intersection
28	xl1=(al-aray)/denom
	if(k1.eq.k2) go to 30
	if (xl1.lt.xg(k1,m1)) go to 32
	if (xl1.gt.xg(k2,m1)) go to 36
c valid intersection found
30	el1=al+bl*xl1
	if (abs (bray).lt.small) bray=sign(small,bray)
	if (bl.gt.blim) bl=blim
	if (bl.lt.-blim) bl=-blim
	denom=1.-bl/bray
	if(abs(denom).lt.small) go to 52
	tanr=(bl+1.0/bray)/denom
	t=sqrt ((xl1-xll)**2+(el1-ell)**2)/vva(m1,l2)
31	tl=tl+t
c test for case where tll starts accumulating at l-1, not l
	if (ll.eq.l.and.l2.eq.(l-1)) go to 43
	tll=tll+t
	go to 44
c intersection not valid -- search to left
32	if (inval.gt.0) go to 30
	if (k1.eq.1) go to 34
	k2=k1
	k1=k2-1
33	inval=-1
 	go to 24
34	if (m1.eq.1) go to 35
	m1=m1-1
	kn=nk(m1)
	k2=kn
	k1=k2-1
	inval=-1
	go to 24
c case of xl1 left of spread 1
35	inval=1
	mflag=1
	go to 324
c intersection not valid -- search to right
36	if (inval.lt.0) go to 30
	if (k2.eq.kn) go to 38
	k1=k2
	k2=k1+1
37	inval=1
	go to 24
38	if (m1.eq.nm) go to 138
	m1=m1+1
	kn=nk(m1)
	k1=1
	k2=2
	inval=1
	go to 24
c case of xl1 right of spread nm
138	inval=-1
	mflag=2
	go to 225
c vertical ray -- test if uppermost -- if so compute tl, tll and exit.
39	xl1=xll
	if (l2.gt.l0) go to 40
	t=(e0-ell)/vva(m1,l2)
	if(t.le.0.) go to 121
	go to 22
c vertical ray -- not uppermost one
40	if(bll.ne.0.) go to 141
	denom=xg(k2,m1)-xg(k1,m1)
	if(denom.gt.0.1) go to 41
	bl=slope
	go to 141
41	bl=(erp(k2,m1,l1)-erp(k1,m1,l1))/denom
	if (bl.gt.blim) bl=blim
	if (bl.lt.-blim) bl=-blim
141	al=erp(k1,m1,l1)-bl*xg(k1,m1)
42	el1=al+bl*xl1
	tanr=bl
	t=(el1-ell)/vva(m1,l2)
	go to 31
c
43	xrefll=xl1
	erefll=el1
	ells=el1
c prepare to continue tracing ray upward
44	xll=xl1
	ell=el1
	sini=vva(m1,l1)*tanr/(sqrt(1.0+tanr**2)*vva(m1,l2))
	tani=sini/sqrt (1.0-sini**2)
	go to 20
c exit from ray-trace routine -- prepare to trace more rays if necessary
46	if (none.gt.0) go to 50
c first ray traced -- store results
	none=none+1
	xs1=x0-xl1
	xrll1=xrefll
	xrl1=xrefl
	erl1=erefl
	erll1=erefll
	tl1=tl
	tll1=tll
	blref1=blref
        epss=abs(xs1)
	if (itrace.ne.0.and.jprt.ne.ibl) write(20,47) none,xl1,xrefll,
     1 erefll,tll,xrefl,erefl,tl,xs1
47	format (22x,'ray',i2,f9.1,9x,6f9.1,f15.1)
	if (abs (xs1).lt.0.5) go to 67
49	xll=xrefl+xs1
	go to 2
c second ray traced -- store results
50	none=none+1
	xs2=x0-xl1
	xrl2=xrefl
	xrll2=xrefll
	erl2=erefl
	erll2=erefll
	tl2=tl
	tll2=tll
	blref2=blref
       	if (abs(xs2).ge.epss) go to 51
	epss=abs(xs2)
	xlls=xrefll
	ells=erefll
	tlls=tll
	xls=xrefl
	els=erefl
	tls=tl
51	if (itrace.ne.0.and.jprt.ne.ibl) write(20,47) none,xl1,xrefll,
     1 erefll,tll,xrefl,erefl,tl,xs2
c make tests for accepting first two rays traced
	if (xs1*xs2.lt.0.0) go to 53
c the two rays are on same side of sp or geo
	if (abs (xs2).lt.abs (xs1)) go to 54
c the 2nd ray is not closer to sp or geo than 1st ray
	if (none.gt.4) go to 52
	xll=xrefl+xs1
       	go to 56
c give up and resort to using saved input values, then return
52	xll=xlls
	ell=ells
	tll=tlls
	xl=xls
	el=els
	tl=tls
	ipath='div: give up'
	go to 63
c test if 2nd ray comes within 10 ft of objective
53	if (abs(xs2).le.10.0) go to 58
c not within 10 ft. if 4 or less rays traced try once more after
c interpolating bl. if more than 4 rays traced, accept last pair.
	if (none.gt.4) go to 58
	iblsw=1
	xll=(xrl1*xs2-xrl2*xs1)/(xs2-xs1)
       	bl=terp(xrl1,blref1,xrl2,blref2,xll)
	xrl1=xrl2
	xrll1=xrll2
	erl1=erl2
	erll1=erll2
	tl1=tl2
	tll1=tll2
	xs1=xs2
	go to 3
c test if extrapolation is permissible
54	if (abs (xs2).le.abs (xs1-xs2)) go to 57
	if (none.gt.4) go to 52
c readjust starting point and then retrace 2nd ray
55	xll=terp(xs1,xrl1,xs2,xrl2,0.0)
56	xrl1=xrl2
	xrll1=xrll2
	erl1=erl2
       	erll1=erll2
	tl1=tl2
	tll1=tll2
	xs1=xs2
	blref1=blref2
	go to 2
c test if 2nd ray within 10 ft of objective
57	if (abs(xs2).le.10.0) go to 58
c not within 10 ft. if 4 or less rays traced try once more, otherwise
c accept the last pair traced.
	if (none.gt.4) go to 58
	go to 55
c interpolate or extrapolate to obtain xll,ell,tll,xl,el,tl, then return
58	xl=terp(xs1,xrl1,xs2,xrl2,0.0)
	xll=terp(xs1,xrll1,xs2,xrll2,0.0)
	ell=terp(xrll1,erll1,xrll2,erll2,xll)
	el=terp(xrl1,erl1,xrl2,erl2,xl)
       	tll=terp(xrll1,tll1,xrll2,tll2,xll)
	tl=terp(xrl1,tl1,xrl2,tl2,xl)
	ipath='interp/extrp'
	if (tl.lt.tll) go to 52
63	if (itrace.ne.0.and.jprt.ne.ibl) write(20,65) ipath,xll,ell,
     1 tll,xl,el,tl,bl
65	format (15x,a12,18x,6f9.1,f9.4)
	if(tlls.ge.big) tll=0.
	return
c very close approximation (.lt.0.5 ft). no further ray tracing needed
67	xll=xrefll
	xl=xrefl
	ell=erefll
	el=erefl
	go to 63
	end
c
c
c ******* Subroutine RAYCOR (#7).  Written 09/06/81  1446.7rew ********
c adjusts coordinates of bottom end point of ray entering or leaving the
c refracting horizon so that total time of computer-traced ray agrees
c with total observed time.
c
	subroutine raycor(x1,x2,e1,e2,vv,hv,tcor)
c
	dx=x1-x2
	de=e1-e2
	denom=sqrt (dx**2+de**2)/vv-abs (dx)/hv
	if (denom.lt.0.1) denom=0.1
	fctr=tcor/denom
	x2=x2-dx*fctr
	e2=e2-de*fctr
5	return
	end
