c ************************ S5.FOR **************************************
c
c Program SIPT1.FOR -- version 1.0 -- USGS, Hartford, CT -- 08-15-86
c
c Micro-computer implementation of sipt22.fortran (on Denver PRIME).
c Compiled on an IBM PC using the IBM Professional FORTRAN compiler
c (version 1.0).
c Program consists of 9 modules: MAIN.FOR, PART2.FOR, PART3.FOR,
c INITIAL.FOR, S1.FOR, S2.FOR, S3.FOR, S4.FOR and S5.FOR.
c
c ************* subroutines resumed ************************************
c
c ***** Subroutine EXTRP (#12).  written 09/06/81  1447.8rew ***********
c computes erp and trp between geos k1 and k2 using equation consts a,b
c
	subroutine extrp(l,m,k1,k2,a,b,vv)
	common/blk2/xg,erp,slope,idip
	common/blk6/trp,jjoff
	common/blk9/eg,es
	dimension xg(48,5),erp(48,5,4),trp(48,5,4),eg(48,5),es(7,5)
c
	do 2 k=k1,k2
	erp(k,m,l)=a+b*xg(k,m)
	if (l.eq.1) go to 1
	trp(k,m,l)=(erp(k,m,l-1)-erp(k,m,l))/vv
	go to 2
1	trp(k,m,l)=(eg(k,m)-erp(k,m,l))/vv
2	continue
	return
	end
c
c
c ****** Subroutine ELCOR (#13).  **************************************written
c computes time corr (tc) and x corr (xc) for surf-to-datum slant rays
c for layer 1, given x pos of shot or geo (xsg), elev of shot or geo
c (esg), intcpt and slope of datum (ad and bd), and sign of boa=cot i
c (i=1 for plus, 2 for minus). xint,eint is coord of intersection of
c ray and datum.
c
	subroutine elcor(tani,vv,hv,xsg,esg,ad,bd,i,tc,xc,xint,eint)
	character*1 jtrl,jprt,jvel,idum
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	dimension nj(5),nk(5)
c
	bi=tani
	if(i.eq.2) bi=-bi
	boa=(1.-bi*bd)/(-bi-bd)
	aoa=esg-boa*xsg
	xint=(ad-aoa)/(boa-bd)
	eint=ad+bd*xint
	oa=sqrt ((xsg-xint)**2+(esg-eint)**2)
	tc=oa/vv
	xc=oa*vv/hv
	if (esg.le.eint) go to 4
3	tc=-tc
	xc=-xc
4	return
	end
c
c
c ***** Subroutine DIP (#14).  written 09/06/81  1447.8rew *************
c computes equation constants a and b (y=a+bx) for regression line
c fitted to erp over geos k1 to k2 with line passing through point
c xg(kk,m),erp(kk,m,l)
c
	subroutine dip(l,m,k1,k2,kk,a,b)
	common/blk2/xg,erp,slope,idip
	dimension xg(48,5),erp(48,5,4)
c
	if (idip.eq.0.and.xg(k1,m).lt.xg(k2,m)) go to 1
	a=erp(kk,m,l)
	b=slope
	go to 4
1	sum1=0.0
	sum2=0.0
	do 2 k=k1,k2
	sum1=sum1+xg(k,m)
	sum2=sum2+1.0
2	continue
	xbar=sum1/sum2
	sum1=0.0
	sum2=0.0
	do 3 k=k1,k2
	xd=xg(k,m)-xbar
	sum1=sum1+xd*erp(k,m,l)
	sum2=sum2+xd**2
3	continue
	b=sum1/sum2
	a=erp(kk,m,l)-b*xg(kk,m)
4	return
	end
c
c
c ****** Subroutine AVG (#15).  written 09/06/81  1447.8rew *************
c computes avg coord (pa,ea) of all pts in arrays (prg,erg) and
c (prs2,ers2) whose x position is ge x1 .and. lt x2. and whose refractor
c is layer l2. if pts.le.2.and.l2.gt.2 interval is expanded by
c dx=x2-x1 on each side.
c
	subroutine avg(x1,x2,l2,pa,ea)
	character*1 ibl,jtrl,jprt,krs2,krg,jvel,idum
	common ibl
	common/blk0/lg
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	common/blk8/prg,erg,prs2,ers2,zrsp,zrg
	common/ibm4/krg,krs2
	dimension lg(48,7,5),nj(5),nk(5),prg(48,7,5),erg(48,7,5),
     1	 krg(48,7,5),prs2(7,5,4,2),ers2(7,5,4,2),krs2(7,5,4,2),zrsp(7),
     1	 zrg(48,7)
c
	sum1=0.0
	sum2=0.0
	pts=0.0
	l1=l2-1
	x11=x1
	x22=x2
	dx=0.0
c
1	do 14 m=1,nm
	jn=nj(m)
	kn=nk(m)
	do 12 j=1,jn
	i=1
2	if (ers2(j,m,l1,i).eq.0..or.krs2(j,m,l1,i).ne.ibl) go to 3
	e1=ers2(j,m,l1,i)
	p1=prs2(j,m,l1,i)
	go to 10
3	if (i.eq.2) go to 5
4	i=2
	go to 2
5	k=1
6	if (lg(k,j,m).ne.l2.or.erg(k,j,m).eq.0.0.or.krg(k,j,m).ne.ibl)
     1	 go to 8
	e1=erg(k,j,m)
	p1=prg(k,j,m)
	i=3
	go to 10
8	k=k+1
	if (k.gt.kn) go to 12
	go to 6
10	if (p1.lt.x11.or.p1.ge.x22) go to 11
	sum1=sum1+p1
	sum2=sum2+e1
	pts=pts+1.0
11	go to (4,5,8),i
12	continue
14	continue
	if (pts.eq.0.0) go to 18
	if (pts.le.2..and.l2.gt.2.and.x1.eq.x11) go to 19
	pa=sum1/pts
	ea=sum2/pts
16	return
18	pa=0.0
	ea=0.0
	go to 16
19	dx=x22-x11
	x11=x11-dx
	x22=x22+dx
	go to 1
	end
c
c
c ***** Subroutine ADMIG (#16).  written 09/06/81  1447.8rew ***********
c computes tan of avg angle of dip (b) of bottom of l1 for spread m
c by regression of points (prs2,ers2) and (prg,erg).
c
	subroutine admig(l1,m,b)
	character*1 ibl,jtrl,jprt,idspr,idsp,krs2,krg,jvel,idum
	common ibl
	common/blk0/lg
	common/blk1/nm,nj,nk
	common/ibm2/jtrl,jprt,jvel,idum
	common/blk2/xg,erp,slope,idip
	common/blk5/idspr,idsp
	common/ibm3/kl,kr,d
	common/blk6/trp,jjoff
	common/blk7/ja,jb,trs,ers,xsp,esp,ls
	common/blk8/prg,erg,prs2,ers2,zrsp,zrg
	common/ibm4/krg,krs2
	common/blk9/eg,es
	common/blk10/blim,itrace,tansg
	dimension nj(5),nk(5),kl(7,5),kr(7,5),lg(48,7,5),ls(7,5),
     1	 prs2(7,5,4,2),ers2(7,5,4,2),krs2(7,5,4,2),prg(48,7,5),
     2	 erg(48,7,5),idspr(5),idsp(7,5),ers(7,5,4),xsp(7,5),esp(7,5),
     3	 d(48,7,5),krg(48,7,5),trp(48,5,4),ja(5),jb(5),trs(7,5,4),
     4   xg(48,5),eg(48,5),es(7,5),erp(48,5,4),zrsp(7),zrg(48,7)
c
	b=0.
	jn=nj(m)
	kn=nk(m)
	l0=l1-1
	l2=l1+1
c
c compute average prg and prs2 (xbar)
c
	s1=0.
	s2=0.
	p1=0.
	p2=0.
c
	do 22 j=1,jn
	jcall=j
c
c up-right and down-left rays
c
	if(kr(j,m).eq.0) go to 18
	call kends(l2,m,jcall,kr(j,m),kn,k11,k22)
	if(k11.eq.0) go to 18
	do 17 k=k11,k22
	if(lg(k,j,m).ne.l2) go to 17
	s1=s1+prg(k,j,m)
	p1=p1+1.
17	continue
	if((jjoff.eq.0.and.j.lt.ja(m)).or.krs2(j,m,l1,1).ne.ibl) go to 18
	s2=s2+prs2(j,m,l1,1)
	p2=p2+1.
c
c up-left and down-right rays
c
18	if(kl(j,m).eq.0) go to 22
	call kends(l2,m,jcall,1,kl(j,m),k11,k22)
	if(k11.eq.0) go to 22
	do 20 k=k11,k22
	if(lg(k,j,m).ne.l2) go to 20
	s2=s2+prg(k,j,m)
	p2=p2+1.
20	continue
	if((jjoff.eq.0.and.j.gt.jb(m)).or.krs2(j,m,l1,2).ne.ibl) go to 22
	s1=s1+prs2(j,m,l1,2)
	p1=p1+1.
22	continue
c
	if((p1+p2).lt.2.) go to 99
	xbar1=0.
	xbar2=0.
	if(p1.ne.0.) xbar1=s1/p1
	if(p2.ne.0.) xbar2=s2/p2
c
c compute average dip (b)
c
	s1=0.
	s2=0.
	ss1=0.
	ss2=0.
	p1=0.
	p2=0.
	do 52 j=1,jn
	jcall=j
c
c up-right and down-left rays
c
	if (kr(j,m).eq.0) go to 48
	call kends(l2,m,jcall,kr(j,m),kn,k11,k22)
	if (k11.eq.0) go to 48
	do 47 k=k11,k22
	if(lg(k,j,m).ne.l2.or.xbar1.eq.0.) go to 47
	x=prg(k,j,m)-xbar1
	s1=s1+x*erg(k,j,m)
	ss1=ss1+x**2
	p1=p1+1.
47	continue
	if((jjoff.eq.0.and.j.lt.ja(m)).or.krs2(j,m,l1,1).ne.ibl.or.
     1 xbar2.eq.0.) go to 48
	x=prs2(j,m,l1,1)-xbar2
	s2=s2+x*ers2(j,m,l1,1)
	ss2=ss2+x**2
	p2=p2+1.
c
c up-left and down-right rays
c
48	if(kl(j,m).eq.0) go to 52
	call kends(l2,m,jcall,1,kl(j,m),k11,k22)
	if(k11.eq.0) go to 52
	do 50 k=k11,k22
	if(lg(k,j,m).ne.l2.or.xbar2.eq.0.) go to 50
	x=prg(k,j,m)-xbar2
	s2=s2+x*erg(k,j,m)
	ss2=ss2+x**2
	p2=p2+1.
50	continue
	if((jjoff.eq.0.and.j.gt.jb(m)).or.krs2(j,m,l1,2).ne.ibl.or.
     1 xbar1.eq.0.) go to 52
	x=prs2(j,m,l1,2)-xbar1
	s1=s1+x*ers2(j,m,l1,2)
	ss1=ss1+x**2
	p1=p1+1.
52	continue
c
       	if((p1+p2).lt.2.) go to 99
	r1=0.
	r2=0.
	if(ss1.ne.0.) r1=s1/ss1
	if(ss2.ne.0.) r2=s2/ss2
	b=(p1*r1+p2*r2)/(p1+p2)
	if(idip.ne.0) b=slope
	if(b.gt.blim) b=blim
	if(b.lt.-blim) b=-blim
c
c migrate ray end points
c
	b1=b
	if(l1.eq.1) b1=(b-slope)/(1.+b*slope)
	cosa=1./sqrt(1.+b1**2)
	zrk=(1.+b1*tansg)*cosa-1.
	xrk=tansg-cosa*(tansg-b1)
	zlk=(1.-b1*tansg)*cosa-1.
	xlk=tansg-cosa*(tansg+b1)
c
c up-right and down-left rays
c
	do 72 j=1,jn
	jcall=j
	if(kr(j,m).eq.0) go to 68
	call kends(l2,m,jcall,kr(j,m),kn,k11,k22)
	if(k11.eq.0) go to 68
	do 67 k=k11,k22
	if(lg(k,j,m).ne.l2.or.xbar1.eq.0.) go to 67
	erg(k,j,m)=erg(k,j,m)-zrg(k,j)*zrk
	prg(k,j,m)=prg(k,j,m)+zrg(k,j)*xrk
67	continue
	if(xbar2.eq.0..or.krs2(j,m,l1,1).ne.ibl) go to 68
	ers2(j,m,l1,1)=ers2(j,m,l1,1)-zrsp(j)*zlk
	prs2(j,m,l1,1)=prs2(j,m,l1,1)-zrsp(j)*xlk
c
c up-left and down-right rays
c
68	if(kl(j,m).eq.0) go to 72
	call kends(l2,m,jcall,1,kl(j,m),k11,k22)
	if(k11.eq.0) go to 72
	do 70 k=k11,k22
	if(lg(k,j,m).ne.l2.or.xbar2.eq.0) go to 70
	erg(k,j,m)=erg(k,j,m)-zrg(k,j)*zlk
	prg(k,j,m)=prg(k,j,m)-zrg(k,j)*xlk
70	continue
	if(xbar1.eq.0..or.krs2(j,m,l1,2).ne.ibl) go to 72
	ers2(j,m,l1,2)=ers2(j,m,l1,2)-zrsp(j)*zrk
	prs2(j,m,l1,2)=prs2(j,m,l1,2)+zrsp(j)*xrk
72	continue
99	return
	end
